package fr.diwaly.minicraft;

import java.util.ArrayList;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;

public class GenKarma {

	private MiniVolcano volcano;
	
	public GenKarma(MiniVolcano v) {
		volcano = v;
	}
	public void init(){
		int x = volcano.refPointX-1;
		int y = volcano.refPointY;
		int z = volcano.refPointZ-1;
		int maxY = volcano.maxY-y+1;
		Block ref = volcano.world.getBlockAt(x, y, z);
		Build.RECTANGLE(ref, BlockFace.SOUTH, BlockFace.UP, BlockFace.WEST, 3, maxY, 3, Material.AIR, Material.MOSSY_COBBLESTONE);
		y = volcano.maxY+1;
		World w = volcano.world;
		Block block0 = w.getBlockAt(x+1, y-1, z+1);
		Block block1 = w.getBlockAt(x, y, z);
		Block block2 = w.getBlockAt(x+2, y, z+2);
		Block block3 = w.getBlockAt(x, y, z+2);
		Block block4 = w.getBlockAt(x+2, y, z);
		
		block0.setType(Material.AIR);
		block1.setType(Material.MOSSY_COBBLESTONE);
		block2.setType(Material.MOSSY_COBBLESTONE);
		block3.setType(Material.MOSSY_COBBLESTONE);
		block4.setType(Material.MOSSY_COBBLESTONE);
	}
	public void clean(){
		int x = volcano.refPointX-2;
		int y = volcano.refPointY;
		int z = volcano.refPointZ-2;
		int maxY = volcano.maxY+3;
		
		// Clean air below
		for (int i = 0; i < 5; i++) {
			for (int j = 0; j < 5; j++) {
				boolean etape1 = true;
				for (int k = maxY; k >= y; k--) {
					Block block = volcano.world.getBlockAt(x+i, k, z+j);
					if (etape1 && !block.isEmpty()){
						etape1 = false;
					}else if(!etape1 && block.isEmpty()){
						block.setType(Material.LAVA);
						break;
					}
				}
			}
		}
		// Clean above 
		volcano.world.createExplosion(volcano.refPointX, volcano.maxY, volcano.refPointZ, 10,true);
	}
	public boolean inZoneKarma(int x, int y, int z){
		return y >= volcano.refPointY && x == volcano.refPointX && z == volcano.refPointZ && y < volcano.refPointY+4;
	}
	public boolean inZoneKarmaChunk(int x, int z){
		return x == volcano.refPointX && z == volcano.refPointZ;
	}
	static public void resetPlayers(){
		for (MiniPlayer player : MiniPlayer.listKarma) {
			player.sendMessage(ChatColor.LIGHT_PURPLE+"You have no longer a good karma.");
			player.karma = false;
		}
		MiniPlayer.listKarma = new ArrayList<MiniPlayer>();
	}
	
}
