package fr.diwaly.minicraft;

import java.util.Random;

import org.bukkit.Location;
import org.bukkit.entity.CreatureType;
import org.bukkit.event.Event;
import org.bukkit.event.entity.CreatureSpawnEvent;
import org.bukkit.event.entity.CreatureSpawnEvent.SpawnReason;
import org.bukkit.event.entity.EntityDeathEvent;
import org.bukkit.event.entity.EntityListener;
import org.bukkit.plugin.PluginManager;

public class MiniListenEntity extends EntityListener{

	public MiniListenEntity() {
		PluginManager pm = Plugin.server.getPluginManager();
		pm.registerEvent(Event.Type.ENTITY_DEATH, this, Event.Priority.Normal, Plugin.him);
		pm.registerEvent(Event.Type.CREATURE_SPAWN, this, Event.Priority.Normal, Plugin.him);
	}
	
	public void onEntityDeath(EntityDeathEvent event) {
		MiniPlayer.onEntityDeath(event);
	}

	public void onCreatureSpawn(CreatureSpawnEvent event) {
		Location loc = event.getLocation();
		MiniVolcano v = Plugin.giveWorldVolcano(loc.getWorld());
		if(v != null && v.insideChunk(loc.getBlockX(),loc.getBlockZ())){
			if(event.getSpawnReason() == SpawnReason.SPAWNER){
				Random rand = new Random();
				if(rand.nextInt(2) == 0){
					event.getEntity().remove();
					v.world.spawnCreature(loc, CreatureType.CREEPER);
				}
			}
		}
	}
}
