package fr.diwaly.minicraft;

import java.util.Hashtable;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.PlayerInventory;
import org.bukkit.util.Vector;

public class MiniSkills{

	static public boolean enable = true; 
	static private Hashtable<Player, PlayerCharge> playersCharge = new Hashtable<Player, PlayerCharge>();
	
	public MiniSkills(){
	}

	static public void onPlayerInteract(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		if(enable && isEquipped(player)){
			Action action = event.getAction();
			// Angel
			if(action == Action.LEFT_CLICK_BLOCK){	
				ItemStack inHand = event.getPlayer().getItemInHand();
				if(inHand.getType() == Material.BOW){
					player.setVelocity(new Vector(0.0, 0.8, 0.0));
				}
			// Peon
			}else if(action == Action.RIGHT_CLICK_BLOCK || action == Action.RIGHT_CLICK_AIR){
				ItemStack inHand = event.getPlayer().getItemInHand();
				if(inHand.getType() == Material.DIAMOND_SWORD){
					if(!playersCharge.containsKey(player))
						playersCharge.put(player, new PlayerCharge());
				}
			}
		}
	}
	
	static public void onPlayerMove(PlayerMoveEvent event) {
		Player player = event.getPlayer();
		if(enable && isEquipped(player)){		
			// Peon
			if(playersCharge.containsKey(player)){
				PlayerCharge skill = playersCharge.get(player);
				
				Location locFrom = event.getFrom();
				Location locTo = event.getTo();
				double x = locTo.getX() - locFrom.getX();
				double z = locTo.getZ() - locFrom.getZ();
				
				if(!skill.init){
					skill = new PlayerCharge(1 ,x*4, z*4);
					playersCharge.put(player, skill);
					player.setVelocity(new Vector(x*8,0,z*8));
					skill.init = true;
				}
				if(skill.duration < Plugin.getTime()){
					playersCharge.remove(player);
				}
			}
		}
	}	
	static private boolean isEquipped(Player player) {
		PlayerInventory inv= player.getInventory();
    	if(inv.getHelmet().getType() == Material.CHAINMAIL_HELMET){
    		if(inv.getBoots().getType() == Material.CHAINMAIL_BOOTS){
    			if(inv.getLeggings().getType() == Material.CHAINMAIL_LEGGINGS){
    				if(inv.getChestplate().getType() == Material.CHAINMAIL_CHESTPLATE){
    		    		return true;
    		    	}
    	    	}
        	}
    	}
    	return false;
	}
}
