package fr.diwaly.minicraft;


import java.util.Random;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.event.Event;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerListener;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.PluginManager;


public class MiniTrap extends PlayerListener {

	@SuppressWarnings("unused")
	private MiniTrapThread mtt;
	public MiniVolcano volcano;
	boolean underWay =  false;
	
	public GenTreasurePiece genTreasure;
	public GenKarma genKarma;
	public GenTrap genTrap;
	
	public MiniTrap(MiniVolcano v) {
		volcano = v;
		mtt = new MiniTrapThread(this, MiniTrapThread.REPEATING);
		
		newTrap();
		
		PluginManager pm = Plugin.server.getPluginManager();
		pm.registerEvent(Event.Type.PLAYER_INTERACT, this, Event.Priority.Normal, Plugin.him);
	}	

	public void beginTrap(){
		underWay = true;	
		// TRAP
		newTrap();
		genTreasure.init();
		genTrap.init();
		// VOLCANO
		volcano.initBeginTrap();
		// KARMA
		genKarma.init();
		Plugin.server.broadcastMessage(ChatColor.GOLD+volcano.name+": gGgggGgrrRRrrrrRrgGGrrrRrr");
		Plugin.log("Begin trap on "+volcano.name);
	}
	public void finishTrap(){
		// TRAP
		underWay = false;
		genTreasure.clean();
		
		Location loc = volcano.world.getSpawnLocation();
		
		// VOLCANO
		volcano.initEndTrap();
		// KARMA
		GenKarma.resetPlayers();
		
		Plugin.log("End trap on "+volcano.name);
	}
	public void openTreasure(MiniPlayer player, ItemStack item){
		openTreasure(player, item, true);
	}
	public void openTreasure(MiniPlayer player, ItemStack item, boolean explode){
		if(player != null){
			// TRAP
			genTreasure.close();
			genTrap.clean();
			genTrap.ifGoodKarma(player.goodKarma());
			// KARMA
			if(player.goodKarma()){
				new MiniTrapThread(this, MiniTrapThread.FINISH, 6);
				if(item != null && item.getType() == Material.GOLD_RECORD){
					Inventory inv = genTreasure.getInventory();
					if(player.rob.get() == null || player.rob.get().getType() != Material.SPONGE){
						inv.addItem(new ItemStack(Material.SPONGE.getId(),1));
					}
					inv.addItem(new ItemStack(Material.BEDROCK.getId(),10));
				}
			}else{
				new MiniTrapThread(this, MiniTrapThread.FINISH, 1);
				player.sendMessage(ChatColor.LIGHT_PURPLE+"No good karma, run forest run !");
				Plugin.server.broadcastMessage(ChatColor.GOLD+player.player.getDisplayName()+" think than Karma isn't important.");
			}
			genKarma.clean();
			// VOLCANO
			if(volcano.isStart() && explode){
				volcano.partExplo = 1;
				new MiniTrapThread(this, MiniTrapThread.ERUPTION,1);
				new MiniTrapThread(this, MiniTrapThread.ERUPTION, 3);
				new MiniTrapThread(this, MiniTrapThread.ERUPTION, 5);
				volcano.afterEruption();
				volcano.enable = false;
				volcano.effusive = false;
			}
		}else{
			MiniPlayer.checkPlayers(volcano.world);
		}
	}
	
	public void onPlayerInteract(PlayerInteractEvent event) {
		// CHEST
		Block block = event.getClickedBlock();
		if(underWay && block != null && event.getAction() == Action.RIGHT_CLICK_BLOCK && genTreasure.isTheChest(block)){
			MiniPlayer player = MiniPlayer.get(event.getPlayer().getName());
			if(player != null)
				openTreasure(player, event.getItem());
		}
	}
	
	static public void onBlockBreak(BlockBreakEvent event) {
		Block block = event.getBlock();
		// CHEST
		if(block.getType() == Material.CHEST){
			MiniVolcano v = Plugin.giveWorldVolcano(block.getWorld());
			if(v!= null && v.trap.genTreasure.isTheChest(block))
				event.setCancelled(true);
		}
	}
	
	public void newTrap(){
		Random rand = new Random();
		int constX = 3;
		int constZ = 3;
		BlockFace faceX;
		BlockFace faceY;
		BlockFace faceZ;
		if(rand.nextBoolean()){
			faceX = BlockFace.SOUTH;
		}else{
			faceX = BlockFace.NORTH;
			constX *= -1;
		}
		if(rand.nextBoolean()){
			faceZ = BlockFace.WEST;
		}else{
			faceZ = BlockFace.EAST;
			constZ *= -1;
		}
		faceY = BlockFace.UP;
		Block ref = volcano.world.getBlockAt(volcano.refPointX+constX, volcano.refPointY, volcano.refPointZ+constZ);
		genTreasure = new GenTreasurePiece(volcano, ref, faceX, faceY, faceZ);
		genKarma = new GenKarma(volcano);
		genTrap = new GenTrap(ref, faceX, faceY, faceZ);
	}
}
