package fr.diwaly.minicraft;

public class MiniTrapThread implements Runnable{

	MiniTrap trap;
	private int task;
	static final public int REPEATING = 0;
	static final public int BEGIN = 1;
	static final public int FINISH = 2;
	static final public int ERUPTION = 3;
	
	public MiniTrapThread(MiniTrap t, int task, int timer) {
		this.trap = t;
		this.task = task;
		if(task == REPEATING){
			Plugin.server.getScheduler().scheduleAsyncRepeatingTask(Plugin.him,this,50,150);
		}else if(task == BEGIN){
			Plugin.server.getScheduler().scheduleSyncDelayedTask(Plugin.him, this);
		}else if(task == FINISH){
			Plugin.server.getScheduler().scheduleSyncDelayedTask(Plugin.him, this, timer*20); // 5sec
		}else if(task == ERUPTION){
			Plugin.server.getScheduler().scheduleSyncDelayedTask(Plugin.him, this,timer*20); 
		}
	}
	public MiniTrapThread(MiniTrap t, int task) {
		this(t, task, 0);
	}
	
	@Override
	public void run() {
		if(task == REPEATING){
			if(!trap.underWay && trap.volcano.effusive && trap.volcano.enable)
				new MiniTrapThread(trap, BEGIN);
		}else if(task == BEGIN){
			trap.beginTrap();
		}else if(task == FINISH){
			trap.finishTrap();
		}else if(task == ERUPTION){
			trap.volcano.setEruption(trap.volcano.baseExplo, trap.volcano.partExplo);
			//Plugin.server.broadcastMessage(ChatColor.GOLD+"BboOOomM !");
		}
	}
}
