package fr.diwaly.minicraft;

import java.io.File;

import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.block.CreatureSpawner;
import org.bukkit.entity.CreatureType;

import fr.diwaly.minicraft.volcano.Flowed;
import fr.diwaly.minicraft.volcano.Plugin;
import fr.diwaly.minicraft.volcano.PopBlock;
import fr.diwaly.minicraft.volcano.Volcano;


public class MiniVolcano extends Volcano{

	public MiniTrap trap;
	
	public int baseExplo = 4;
	public int partExplo = 1;
	
	public MiniVolcano(File file){
		super(file);
		trap = new MiniTrap(this);
	}
	
	public MiniVolcano(World world, String name, int maxY, int x, int y, int z){
		super(world, name, maxY, x, y, z);
		trap = new MiniTrap(this);
	}
	
	public void update(){
    	while(!listFlowed.isEmpty() && listFlowed.peek().timeFlowed < Plugin.getTime()){
    		Flowed flowed = listFlowed.poll();
			// Suppression des bloc en dessous de la coule
    		if (effusive){
    			flowed.block.setType(Material.AIR);
			}else if (flowed.y() > maxY-6){
				if(flowed.y() == maxY){
    				removeBlock(flowed.block);
    			}else if(rand.nextBoolean()){
    				flowed.block.setType(Material.GRAVEL);
    			}else{
    				int num = getLayer(flowed.x(), flowed.y(), flowed.z());
    				flowed.block.setType(randomBlock(num));
    			}
			}else{
				int num = getLayer(flowed.x(), flowed.y(), flowed.z());
				// Ajout bloc de mineraux au hazard
				 flowed.block.setType(randomBlock(num));
				 if(flowed.block.getType() == Material.MOB_SPAWNER){
					 ((CreatureSpawner)flowed.block.getState()).setCreatureType(CreatureType.PIG_ZOMBIE);
				 }				 
			}
		}	
	}
	
	public boolean inZoneActiv(int x, int z){
		int zone = 150;
		return x < refPointX + zone && x > refPointX - zone && z < refPointZ + zone && z > refPointZ - zone;
	}
	public boolean inSaw(int x, int z){
		int zone = 130;
		return x < refPointX + zone && x > refPointX - zone && z < refPointZ + zone && z > refPointZ - zone;
	}
	public boolean inSecure(int x, int z){
		int zone = 150;
		return x < refPointX + zone && x > refPointX - zone && z < refPointZ + zone && z > refPointZ - zone;
	}
	public void setEruption(int base, int n){
		
		int part = xF.length/base;
		int num = rand.nextInt(part);
		num = num+(part*(n-1));
		Block block = goodHeight(num);
		
		int x = block.getX();
		int y = block .getY();
		int z = block.getZ();
		Block tntA = world.getBlockAt(x-2, y, z-2);
		Block tntB = world.getBlockAt(x+2, y, z-2);
		Block tntC = world.getBlockAt(x+2, y, z+2);
		Block tntD = world.getBlockAt(x-2, y, z+2);
		tntA.setType(Material.TNT);
		tntB.setType(Material.TNT);
		tntC.setType(Material.TNT);
		tntD.setType(Material.TNT);
		
		Block tntZ = world.getBlockAt(x, y, z);
		tntZ.setType(Material.TNT);
		world.createExplosion(x, y, z, 5, true);
		Plugin.log(name+" Boom !");
		partExplo++;
	}
	public void setEruption(){
		setEruption(1, 1);
	}
	
	public void createDefault(){
		setEffusive();
		refPointY = 65;
		maxY = 115;
		
		initTimerBetweenFlowed(2);
		initTimerFlowed(2);
		
		initLayer();
		PopBlock popy = new PopBlock();
		popy.put(75.0, Material.STONE);
		popy.put(25.0, Material.MOSSY_COBBLESTONE);
		addLayer(0, popy.machine());
		
		popy = new PopBlock();
		popy.put(97.70, Material.STONE);
		popy.put(0.1, Material.DIAMOND_ORE);
		popy.put(0.1, Material.GOLD_ORE);
		popy.put(0.1, Material.IRON_ORE);
		popy.put(1.0, Material.COAL_ORE);
		popy.put(0.1, Material.LAPIS_ORE);
		popy.put(0.1, Material.REDSTONE_ORE);
		popy.put(0.1, Material.CLAY);
		popy.put(0.05, Material.MOB_SPAWNER);
		popy.put(0.1, Material.WEB);
		popy.put(0.5, Material.TNT);
		popy.put(0.5, Material.GLOWSTONE);
		addLayer(15, popy.machine());
		
		popy = new PopBlock();
		popy.put(100.0, Material.GRASS);addLayer(49, popy.machine());
		
	}
	public void initBeginTrap(){
		initTimerBetweenFlowed(2);
		initTimerFlowed(2);
		save();
	}
	
	public void initEndTrap(){
		initTimerBetweenFlowed(5);
		initTimerFlowed(4);
		save();
	}
	
}
