package fr.diwaly.minicraft;

import java.io.File;
import java.util.logging.Logger;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Server;
import org.bukkit.World;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.java.JavaPlugin;

public class Plugin extends JavaPlugin{
	static public Plugin him;
	static final private Logger log = Logger.getLogger("Minecraft");
	static public Server server;
	static public File dataFolder;
	static final public String tag = "[MinicraftVolcano] ";
	static private PluginVolcano pluginVolcano;
	
	@Override
	public void onDisable() {
	}

	@Override
	public void onEnable() {
		him = this;
		server = him.getServer();
		dataFolder = him.getDataFolder();
		dataFolder.mkdir();
		pluginVolcano = new PluginVolcano(this);
		pluginVolcano.onEnable();
		
		new MiniListenBlock();
		new MiniListenPlayer();
		new MiniListenEntity();
		
		PluginDescriptionFile pdfFile = him.getDescription();
        log( pdfFile.getName() +" "+pdfFile.getVersion() + " is enabled!" );
	}

	public boolean onCommand(CommandSender sender, Command command,	String label, String[] args) {		
		if(!(sender instanceof Player))
    		return false;
    	Player player = (Player)sender;
    	if(player.isOp()){
	    	// **** VOLCANO ****
	    	if(label.equalsIgnoreCase("miniv") && args.length > 0){
	    		if(args[0].equalsIgnoreCase("help") ){
	    			player.sendMessage(ChatColor.GRAY+"*** HELP VOLCANO ***");
	    			player.sendMessage(ChatColor.GRAY+"/miniv - Distance between the spawn point and you.");
					player.sendMessage(ChatColor.GRAY+"/miniv create <name> - Create volcano.");
					//player.sendMessage(ChatColor.GRAY+"/miniv create <name> <height> <rate nameBloc> ... - Create volcano.");
					player.sendMessage(ChatColor.GRAY+"/miniv layer help - Help for add the layers.");
					player.sendMessage(ChatColor.GRAY+"/miniv stop <name> - Stop a volcano.");
					player.sendMessage(ChatColor.GRAY+"/miniv start <name> - Start a volcano.");
					player.sendMessage(ChatColor.GRAY+"/miniv list - List of volcanoes.");
					player.sendMessage(ChatColor.GRAY+"/miniv del <name> - Delete a volcano file.");
					player.sendMessage(ChatColor.GRAY+"/miniv load <name> - Load a volcano file.");
					//player.sendMessage(ChatColor.GRAY+"/miniv timer <name> [<second>] - Time between flowed.");
					//player.sendMessage(ChatColor.GRAY+"/miniv flowed <name> [<second>] - Time of flowed before transformation.");
					//player.sendMessage(ChatColor.GRAY+"/miniv erupt <name> explo|effu - Mode of eruption.");
					player.sendMessage(ChatColor.GRAY+"/miniv info <name> - Information about a volcano.");
					//player.sendMessage(ChatColor.GRAY+"/miniv near - Display the near volcanoes.");
					player.sendMessage(ChatColor.GRAY+"/miniv allow [<from>] - List of allow blocks.");
					player.sendMessage(ChatColor.GRAY+"/miniv world <nameWorld> - Allow/Forbidden a world for the minicraft volcano plugin.");
					//player.sendMessage(ChatColor.GRAY+"/miniv ops - Permit the volcano plugin only for ops or allow for everybody. (op)");

					return true;
	    		}else if(args[0].equalsIgnoreCase("create") && args.length == 2){	
	    			MiniVolcano v = giveWorldVolcano(player.getWorld());
	    			if(v == null){
		    			// Un volcano par world
	    				args = new String[]{args[0], args[1], "10", "100", "STONE"};
		    			pluginVolcano.onCommand(sender, command, "volcano", args);
		    			MiniVolcano volcano = giveWorldVolcano(player.getWorld());
		    			if(volcano !=null){
		    				volcano.createDefault();
		    				volcano.save();
		    				MiniPlayer.checkPlayers(player.getWorld());
		    			}
		    			return true;
	    			}else{
	    				player.sendMessage(ChatColor.GRAY+v.name+" is on this world.");
	    				return true;
	    			}
	    		}else if(args[0].equalsIgnoreCase("timer")){
	    			return false;
	    		}else if(args[0].equalsIgnoreCase("flowed")){
	    			return false;	    		
	    		}else if(args[0].equalsIgnoreCase("erupt")){
	    			return false;
	    		}else if(args[0].equalsIgnoreCase("near")){
	    			return false;
	    		}else if(args[0].equalsIgnoreCase("ops")){
	    			return false;
	    		}
	    		
	    		// Execution normal
	    		pluginVolcano.onCommand(sender, command, "volcano", args);
	    		return true;
	    	}else if(label.equalsIgnoreCase("miniv") && args.length == 0){
	    		World w = player.getWorld();
	    		Location locS = w.getSpawnLocation();
	    		Location locP = player.getLocation();
	    		int x = locP.getBlockX() - locS.getBlockX();
	    		int z = locP.getBlockZ() - locS.getBlockZ();
	    		int distance = (x < z)?z:x;
	    		distance = (distance < 0)?-distance:distance;
	    		if(distance > 200){
	    			player.sendMessage(ChatColor.GREEN+"You are "+distance+" blocks from spawn point.");
	    		}else{
	    			player.sendMessage(ChatColor.RED+"You are "+distance+" blocks from spawn point.");
	    		}	    		
	    	}else{
	    	// **** MINICRAFT ****
	    		String display = "";
	        	for (int i = 0; i < args.length; i++) {
	        		display+=" "+args[i];
	    		}
	        	log(player.getName()+":"+display);
	        	if(label.equalsIgnoreCase("mini") && args.length == 1){
	        		String cmd = args[0];
	        		if(cmd.equalsIgnoreCase("help")){
	        			player.sendMessage(ChatColor.GRAY+"*** HELP MINICRAFT ***");
	        			player.sendMessage(ChatColor.GRAY+"/mini begin <name> - Begin event.");
	        			player.sendMessage(ChatColor.GRAY+"/mini end <name> - End event.");
	        			player.sendMessage(ChatColor.GRAY+"/mini default <name> - Load default configuration.");
	        			return true;
	        		}
	        	}
	        	
	        	if(label.equalsIgnoreCase("mini") && args.length == 2){
	        		String cmd = args[0];
	        		String name = args[1];
	        		MiniVolcano v = (MiniVolcano) giveVolcano(name);
	        		if(v != null){
		        		if(cmd.equalsIgnoreCase("begin")){
		        			v.trap.beginTrap();
		    				return true;
		        		}	
		        		if(cmd.equalsIgnoreCase("end")){
		        			MiniPlayer miniP = MiniPlayer.get(player.getName());
		        			if(miniP != null){
		        				if(v.effusive){
		        					v.trap.openTreasure(miniP, player.getItemInHand());
		        				}else{
		        					v.trap.openTreasure(miniP, player.getItemInHand(), false);
		        				}
		        			}else{
		        				player.sendMessage(ChatColor.GRAY+player.getName()+" isn't known by the plugin.");
		        			}
		    				return true;
		        		}
		        		if(cmd.equalsIgnoreCase("default")){
			    			v.createDefault();
			    			v.save();
			    			player.sendMessage(ChatColor.GRAY+v.name+" has default configuration.");
			    			return true;
			    		}
		        		if(cmd.equalsIgnoreCase("init")){
		        			v.trap.genTreasure.init();
		        			v.trap.genTrap.init();
		        			return true;
		        		}
		        		if(cmd.equalsIgnoreCase("clean")){
		        			v.trap.genTrap.clean();
		        			v.trap.genTrap.ifGoodKarma(true);
		        			v.trap.genTreasure.clean();
		        			return true;
		        		}
	        		}
	        		if(cmd.equalsIgnoreCase("info")){
	        			MiniPlayer p = MiniPlayer.get(name);
	        			if(p != null){
	        				player.sendMessage(ChatColor.DARK_GRAY+"rob X: "+p.rob.X);
	        				player.sendMessage(ChatColor.DARK_GRAY+"rob Y: "+p.rob.Y);
	        				player.sendMessage(ChatColor.DARK_GRAY+"rob Z: "+p.rob.Z);
	        			}
	        		}
	        	} 
	        	return false;
	    	}
	    	return true;
    	}
    	return false;
	}

	
	@SuppressWarnings("static-access")
	static MiniVolcano giveVolcano(String name){
		return pluginVolcano.giveVolcano(name);
	}

	@SuppressWarnings("static-access")
	static public MiniVolcano giveWorldVolcano(World w){
		return pluginVolcano.giveWorldVolcano(w);
	}
	static final public long getTime(){
		return System.currentTimeMillis();
	}
	static public void log(String msg){
		log.info(tag+msg);
	}
}
