package fr.diwaly.minicraft;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;

public class SpongeRob{
	
	private MiniPlayer player;
	public World world;
	public int X;
	public int Y;
	public int Z;
	private Block rob;
	
	static private int radius = 5;
	
	public SpongeRob(MiniPlayer p){		
		player = p;
	}
	
	public Block get(){
		return rob;
	}
	public void set(Block b){
		X = b.getX();
		Y = b.getY();
		Z = b.getZ();
		world = b.getWorld();
		rob = b;
	}
	// ***** ON INTERACT *****
	static public void onPlayerInteract(PlayerInteractEvent event) {
		Block block = event.getClickedBlock();	
		if(block != null){
			Player player = event.getPlayer();
			ItemStack item = event.getPlayer().getItemInHand();
			// CLIC GAUCHE 
			if(event.getAction() == Action.LEFT_CLICK_BLOCK){
				// SPONGE ROB
				if(block.getType() == Material.SPONGE){
					if(canInteract(player, block)){
						talk(player);
					}
				}else if(item.getType() == Material.GOLD_RECORD){
					if(nearRob(block) != null)
						player.sendMessage(ChatColor.GRAY+"You are near a Sponge Rob.");
					MiniVolcano v = Plugin.giveWorldVolcano(block.getWorld());
					if(v != null){
						if(v.inSecure(block.getX(), block.getZ())){
							if(v.inSaw(block.getX(), block.getZ())){
								player.sendMessage(ChatColor.RED+"You are near a volcano.");
							}else{
								player.sendMessage(ChatColor.GREEN+"You are in secure zone.");
							}
							
						}else{
							player.sendMessage(ChatColor.GRAY+"Where are you ? :)");
						}
					}
				}
			}
			// CLIC DROIT
			else if(event.getAction() == Action.RIGHT_CLICK_BLOCK){
				// CHEST
				if(block.getType() == Material.CHEST){
					Block rob = nearRob(block);
					if(rob != null){
						if(canInteract(player, rob)){
							player.sendMessage(ChatColor.GRAY+"Chest secure.");
						}else{
							event.setCancelled(true);
							player.sendMessage(ChatColor.GRAY+"Chest lock.");
						}
					}
					// GOLD DISC
				}else if(item.getType() == Material.GOLD_RECORD){
					if(block.getType() == Material.CHEST || block.getType() == Material.SPONGE){
						event.setCancelled(true);
						player.sendMessage(ChatColor.RED+"You can disappear only bedrock.");
					}else{
						Block rob = nearRob(block);
						if(rob != null){
							if(canInteract(player, rob) && block.getType() == Material.BEDROCK){
								block.setType(Material.AIR);
								player.sendMessage(ChatColor.GRAY+"pschitt !");
							}else{
								event.setCancelled(true);
								player.sendMessage(ChatColor.RED+"You can disappear only bedrock.");
							}
						}
					}
				}
			}
		}	
	}
	// ***** ON BREAK *****
	static public void onBlockBreak(BlockBreakEvent event) {
		Block block = event.getBlock();				
		// SPONGE ROB & CHEST
		if(block.getType() == Material.SPONGE){
			Player player = event.getPlayer();
			if(!canInteract(player, block)){
				event.setCancelled(true);
				player.sendMessage(ChatColor.GRAY+"He isn't your friend Rob.");
			}
		}else if(block.getType() == Material.CHEST){
			Block rob = nearRob(block);
			if(rob != null){
				Player player = event.getPlayer();
				if(!canInteract(player, rob)){
					event.setCancelled(true);
					player.sendMessage(ChatColor.RED+"Chest secure.");
				}
			}
		}
	}
	// ***** ON PLACE *****
	static public void onBlockPlace(BlockPlaceEvent event){
		Block block = event.getBlock();
		Player player = event.getPlayer();	
		// TNT
		if(block.getType() == Material.TNT){
			if(nearRob(block) != null){
				event.setCancelled(true);
				player.sendMessage(ChatColor.GRAY+"Near a Sponge rob.");
			}	
		// BEDROCK
		}else if(block.getType() == Material.BEDROCK){
			Block rob = nearRob(block);
			if(rob != null){
				if(!canInteract(player, rob)){
					event.setCancelled(true);
					player.sendMessage(ChatColor.GRAY+"Need your Sponge Rob.");
				}
			}else{
				event.setCancelled(true);
				player.sendMessage(ChatColor.GRAY+"Need your Sponge Rob.");
			}
						
		// SPONGE ROB
		}else if(block.getType() == Material.SPONGE){
			MiniVolcano v = Plugin.giveWorldVolcano(block.getWorld());
			if(v != null && v.inSecure(block.getX(), block.getZ()) && !v.inSaw(block.getX(), block.getZ())){
				if(nearRob(block, 2) == null){
					// Nouvelle bande
					MiniPlayer p = MiniPlayer.get(player.getName());
					if(p != null){
						if(!p.band.newBand(block)){
							// Deja une bande
							event.setCancelled(true);
							player.sendMessage(ChatColor.RED+"You have already a band.");
						}
					}else{
						event.setCancelled(true);
						player.sendMessage(ChatColor.GRAY+player.getName()+" isn't known by the plugin.");
					}
				}else{
					event.setCancelled(true);
					player.sendMessage(ChatColor.GRAY+"Near a Sponge Rob.");
				}
			}else{
				event.setCancelled(true);
				player.sendMessage(ChatColor.RED+"You aren't in secure zone");
			}
		// BED
		}else if(block.getType() == Material.BED_BLOCK){
			MiniVolcano v = Plugin.giveWorldVolcano(block.getWorld());
			if(v != null && v.inSaw(block.getX(), block.getZ())){
				event.setCancelled(true);
				player.sendMessage(ChatColor.RED+"you aren't in secure zone");
			}
		}
	}		
	
	static public Block nearRob(Block b){
		return nearRob(b, 1);
	}
	static public Block nearRob(Block b, int coef){
		int debut = (radius*coef)*-1;
		int fin = (radius*coef)+1;
		for (int i = debut; i < fin; i++) {
			for (int j = debut; j < fin; j++) {
				for (int k = debut; k < fin; k++) {
					if(!(i == 0 && j ==0 && k == 0)){
						Block block = b.getWorld().getBlockAt(b.getX()+i, b.getY()+k, b.getZ()+j);
						if(block.getType() == Material.SPONGE){
							return block;
						}
					}
				}
			}	
		}
		return null;
	}
	static public boolean canInteract(Player p, Block b){
		MiniPlayer pp = MiniPlayer.get(p.getName());
		if(pp == null)
			return false;
		return pp.rob.rob == b;
	}

	static public void talk(Player p){
		p.sendMessage(ChatColor.DARK_GREEN+"pPppoOOOooaaAAaahhHH !!");
	}
	
}
